Skip to main content
POST
/
conversations
/
custom-channels
/
2026-03
/
{channelId}
/
messages
Publish a message
curl --request POST \
  --url https://api.hubapi.com/conversations/custom-channels/2026-03/{channelId}/messages \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "attachments": [
    {
      "fileId": "<string>",
      "type": "FILE"
    }
  ],
  "channelAccountId": "<string>",
  "recipients": [
    {
      "deliveryIdentifier": {
        "value": "<string>"
      },
      "name": "<string>",
      "senderActorId": "<string>"
    }
  ],
  "senders": [
    {
      "deliveryIdentifier": {
        "value": "<string>"
      },
      "name": "<string>",
      "senderActorId": "<string>"
    }
  ],
  "text": "<string>",
  "timestamp": "2023-11-07T05:31:56Z",
  "associateWithContactId": 123,
  "inReplyToId": "<string>",
  "integrationIdempotencyId": "<string>",
  "integrationThreadId": "<string>",
  "richText": "<string>"
}
'
import requests

url = "https://api.hubapi.com/conversations/custom-channels/2026-03/{channelId}/messages"

payload = {
"attachments": [
{
"fileId": "<string>",
"type": "FILE"
}
],
"channelAccountId": "<string>",
"recipients": [
{
"deliveryIdentifier": { "value": "<string>" },
"name": "<string>",
"senderActorId": "<string>"
}
],
"senders": [
{
"deliveryIdentifier": { "value": "<string>" },
"name": "<string>",
"senderActorId": "<string>"
}
],
"text": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"associateWithContactId": 123,
"inReplyToId": "<string>",
"integrationIdempotencyId": "<string>",
"integrationThreadId": "<string>",
"richText": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
attachments: [{fileId: '<string>', type: 'FILE'}],
channelAccountId: '<string>',
recipients: [
{
deliveryIdentifier: {value: '<string>'},
name: '<string>',
senderActorId: '<string>'
}
],
senders: [
{
deliveryIdentifier: {value: '<string>'},
name: '<string>',
senderActorId: '<string>'
}
],
text: '<string>',
timestamp: '2023-11-07T05:31:56Z',
associateWithContactId: 123,
inReplyToId: '<string>',
integrationIdempotencyId: '<string>',
integrationThreadId: '<string>',
richText: '<string>'
})
};

fetch('https://api.hubapi.com/conversations/custom-channels/2026-03/{channelId}/messages', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "archived": true,
  "attachments": [
    {
      "fileId": "<string>",
      "type": "FILE",
      "name": "<string>",
      "url": "<string>"
    }
  ],
  "channelAccountId": "<string>",
  "channelId": "<string>",
  "client": {
    "integrationAppId": 123
  },
  "conversationsThreadId": "<string>",
  "createdAt": "2023-11-07T05:31:56Z",
  "createdBy": "<string>",
  "id": "<string>",
  "recipients": [
    {
      "deliveryIdentifier": {
        "value": "<string>"
      },
      "actorId": "<string>",
      "name": "<string>",
      "recipientField": "<string>"
    }
  ],
  "senders": [
    {
      "actorId": "<string>",
      "deliveryIdentifier": {
        "value": "<string>"
      },
      "name": "<string>",
      "senderField": "<string>"
    }
  ],
  "text": "<string>",
  "type": "MESSAGE",
  "inReplyToId": "<string>",
  "richText": "<string>",
  "status": {
    "failureDetails": {
      "errorMessageTokens": {},
      "errorMessage": "<string>"
    }
  },
  "subject": "<string>",
  "updatedAt": "2023-11-07T05:31:56Z"
}
{
"message": "Invalid input (details will vary based on the error)",
"correlationId": "aeb5f871-7f07-4993-9211-075dc63e7cbf",
"category": "VALIDATION_ERROR",
"links": {
"knowledge-base": "https://www.hubspot.com/products/service/knowledge-base"
}
}

Supported products

Authorizations

Authorization
string
header
required

The access token received from the authorization server in the OAuth 2.0 flow.

Path Parameters

channelId
integer<int32>
required

Body

application/json
attachments
(FILE · object | LOCATION · object | CONTACT · object | UNSUPPORTED_CONTENT · object | MESSAGE_HEADER · object | QUICK_REPLIES · object | SOCIAL_MEDIA_METADATA · object)[]
required
channelAccountId
string
required
messageDirection
enum<string>
required
Available options:
INCOMING,
OUTGOING
recipients
object[]
required
senders
object[]
required
text
string
required
timestamp
string<date-time>
required
associateWithContactId
integer<int64>
inReplyToId
string
integrationIdempotencyId
string
integrationThreadId
string
preResolvedContacts
object
richText
string

Response

successful operation

archived
boolean
required
attachments
(FILE · object | LOCATION · object | CONTACT · object | UNSUPPORTED_CONTENT · object | MESSAGE_HEADER · object | QUICK_REPLIES · object | WHATSAPP_TEMPLATE_METADATA · object | SOCIAL_MEDIA_METADATA · object)[]
required
channelAccountId
string
required
channelId
string
required
client
object
required
conversationsThreadId
string
required
createdAt
string<date-time>
required
createdBy
string
required
direction
enum<string>
required
Available options:
INCOMING,
OUTGOING
id
string
required
recipients
object[]
required
senders
object[]
required
text
string
required
truncationStatus
enum<string>
required
Available options:
NOT_TRUNCATED,
TRUNCATED,
TRUNCATED_TO_MOST_RECENT_REPLY
type
enum<string>
default:MESSAGE
required
Available options:
MESSAGE
inReplyToId
string
richText
string
status
object
subject
string
updatedAt
string<date-time>
Last modified on March 31, 2026